/*  -*- Mode: C -*- 
 * This file is part of xnetmaj
 * 
 * itemtype.h -- 
 * 
 * $Id$
 * Author          : NBC02365@niftyserve.or.jp
 * Created On      : Thu Jan 25 23:01:25 1996
 * Last Modified By: NBC02365@niftyserve.or.jp
 * Last Modified On: Thu Jan 25 23:01:26 1996
 * 
 * Copyright (C) 1995,1996 Todo Software All rights reserved.
 */

/* 
   item type 
 */
typedef struct item_type
  {
    char *name;
    integer_t type;
    integer_t size;
    struct
      {
	widget_t (*create) ();
	void (*destroy) ();
	void (*configure) ();
	void (*display) ();
	void (*action) ();
	void (*invoke) ();
	void (*clear) ();
      }
    proc;
    struct item_type *next;
  }
 *item_type_t;

/* 
   model 
 */
enum relief_type
  {
    relief_none, relief_sunken, relief_raised, relief_flat, relief_frame
  };


#define _offsetof(s, t)   (unsigned long)(&(((s *)0)->t))


typedef struct configure
  {
    integer_t resourceid;
    integer_t datatype;
    integer_t offset;
    void *value;
  }
 *configure_t;

#define widget_type_menu        1
#define widget_type_frame       2
#define widget_type_menuitem    3
#define widget_type_button      4
#define widget_type_toplevel    5
#define widget_type_pixmapframe 6
#define widget_type_text        7
#define widget_type_pmcontainer 8
#define widget_type_canvas      9
#define widget_type_radio       10
#define widget_type_core        100

#define widget_configure(a, b, c)  _widget_configure(a, b, (void *)(c))
