/*  -*- Mode: C -*- 
 * This file is part of xnetmaj
 * 
 * xnet.c -- 
 * 
 * $Id: board.c,v 1.1 1995/04/23 01:32:45 ksr Exp ksr $
 * Author          : NBC02365@niftyserve.or.jp
 * Created On      : Tue Apr 11 11:14:04 1995
 * Last Modified By: NBC02365@niftyserve.or.jp
 * Last Modified On: Thu Jan 25 22:53:39 1996
 *
 *  Copyright (C) 1995,1996 Todo Software All rights reserved
 */

#include "xnet.h"

static widget_t root;
widget_t board;

integer_t xheight = 480;
integer_t xwidth = 640;

integer_t flag_enable_select = 0;
integer_t flag_enable_onboard = 0;
integer_t flag_effect = 0;
integer_t n_select;
integer_t choiced;


integer_t iam;

extern integer_t yellow, white, purple, blue;

static void select_pai_callback callbackarg_param
{
  integer_t idx = val;
  integer_t x, y, n;
  if (!flag_enable_select)
    {
      return;
    }
  if (!(idx == 5 || idx == iam))
    {				/* 5 means this func is called from choice */
      return;
    }
  if (idx != 5 && !flag_enable_onboard)
    {
      return;
    }
  x = (arg->x - HANDPAISTART);	/* get clicked pos */
  y = arg->y;
  n = x / PAI_W;
  if (n_select != 0 && n == n_select)
    {
      n = (x - HANDPAIMARGIN) / PAI_W;	/* choice widen */
    }
  if (!(0 <= n && n < n_select))
    {
      return;			/* do nothing */
    }
  snd (audioplay_pai ());

  flag_enable_select = 0;
  flag_enable_onboard = 0;
  choiced = n;
  flag_effect = 1;
}

void
board_button3press_callback ()
{
  if (!widget_map_p (board))
    {
      return;
    }
  if (flag_enable_select
      && flag_enable_onboard)
    {
/* tumogiri: call from choice (mode, not res mode) */
/* n_select is n pais; tumo is always (n_select - 1) */
      choiced = n_select - 1;
      snd (audioplay_tumogiri ());
    }
  else
    {
      choiced = X_CANCEL;
      snd (audioplay_cancel ());
    }
  flag_enable_select = 0;
  flag_enable_onboard = 0;
  flag_effect = 1;

}

static void cancel_button_callback callbackarg_param
{
  keywait_callback ();
  flag_enable_select = 0;
  flag_effect = 1;
  choiced = X_CANCEL;
  snd (audioplay_cancel ());
}

static void tie_button_callback callbackarg_param
{
  flag_effect = 1;
  choiced = X_TIE;
  snd (audioplay_tie ());
}

static void pon_button_callback callbackarg_param
{
  flag_effect = 1;
  choiced = X_PON;
  snd (audioplay_pon ());
}

static void kan_button_callback callbackarg_param
{
  flag_effect = 1;
  choiced = X_KAN;
  snd (audioplay_kan ());
}

static void ron_button_callback callbackarg_param
{
  flag_effect = 1;
  choiced = X_RON;
  snd (audioplay_ron ());
}

static void tumo_button_callback callbackarg_param
{
  flag_effect = 1;
  choiced = X_TUMO;
  snd (audioplay_tumo ());
}

static void reach_button_callback callbackarg_param
{
  flag_effect = 1;
  choiced = X_REACH;
  snd (audioplay_reach ());
}

extern void restart_callback ();
extern void flush_callback ();
extern void speed_callback ();
extern void one_callback ();
extern void auto_callback ();
extern void autoplay_callback ();
extern void auto_after_reach_callback ();
extern void visible_callback ();
extern void about_callback ();
extern void advice_button_callback ();
extern void help_callback ();
extern void stop_button_callback ();
extern void sound_button_callback ();
extern void config_callback ();
extern void rule_callback ();

void quit_callback callbackarg_param
{
  extern global_t *game_global;
    do_disconnect (game_global);
    term ();
}

#if X11
void
check_callback (gp)
     global_t *gp;
{
  int fd;
  if (!gp)
    return;
  fd = callback_fd (gp);
  if (fd == -1)
    {
      callback (gp);
    }
}
#endif

void
get_choice (gp)
     global_t *gp;
{
  extern widget_t root_widget;
  flag_effect = 0;
  widget_event_discard (root_widget);
  for (; flag_effect == 0;)
    {
#if XCLIENT
      if (widget_eventsqueued (root_widget))
	{
	  _widget_handle_event ();
	}
      else
	{
	  check_callback (gp);
	}
#else
      if (widget_eventsqueued (root_widget))
	{
	  _widget_handle_event ();
	}
      invoke_handlers ();
#endif
    }
}



void
board_sync ()
{
  widget_sync (board);
}

void
board_flush_sfx ()
{
  static int i = 0;
  if (i++ % 2)
    {
      widget_flush_sfx_blind (board, 20, 20);
    }
  else
    {
      widget_flush_sfx_shatter (board, 10, 10);
    }
  widget_sync (board);
}


void
board_flush ()
{
  widget_flush (board);
}

void
board_button_flush ()
{
  widget_flush (action);
}

void
board_display ()
{
  widget_display (board);
}

extern widget_t root_widget;

#if 0
#if XCLIENT
#if X11
#define X11CL(x) x
#define NMX(x)
#else
#define X11CL(x)
#define NMX(x) x
#endif
#define NMCL(x)   x
#define NM1CL(x)
#else
#define X11CL(x)
#define NMCL(x)
#define NM1CL(x)  x
#if X11
#define NMX(x)
#else
#define NMX(x)  x
#endif
#endif
#endif



static void
build_status (status1)
     widget_t status1;
{
#if 0
  NMX (sound_button = widget_create ("button", status1));
  X11CL (one_button = widget_create ("button", status1));
  stop_button = widget_create ("button", status1);
  config_button = widget_create ("button", status1);
  visible_button = widget_create ("button", status1);
  NM1CL (speed_button = widget_create ("button", status1));
  X11CL (autoplay_button = widget_create ("button", status1));
  NMCL (auto_after_reach_button = widget_create ("button", status1));
  flush_button = widget_create ("button", status1);
  X11CL (restart_button = widget_create ("button", status1));
  NMCL (auto_button = widget_create ("button", status1));
  about_button = widget_create ("button", status1);
  NMX (help_button = widget_create ("button", status1));
  quit_button = widget_create ("button", status1);

  NMX (widget_set_geometry (sound_button, MBUTTON_W, MBUTTON_H));
  widget_set_geometry (stop_button, MBUTTON_W, MBUTTON_H);
  NM1CL (widget_set_geometry (speed_button, MBUTTON_W, MBUTTON_H));
  widget_set_geometry (visible_button, MBUTTON_W, MBUTTON_H);
  X11CL (widget_set_geometry (autoplay_button, MBUTTON_W, MBUTTON_H));
  NMCL (widget_set_geometry (auto_after_reach_button, MBUTTON_W, MBUTTON_H));
  widget_set_geometry (flush_button, MBUTTON_W, MBUTTON_H);
  X11CL (widget_set_geometry (restart_button, MBUTTON_W, MBUTTON_H));
  X11CL (widget_set_geometry (one_button, MBUTTON_W, MBUTTON_H));
  NMCL (widget_set_geometry (auto_button, MBUTTON_W, MBUTTON_H));
  widget_set_geometry (about_button, MBUTTON_W, MBUTTON_H);
  NMX (widget_set_geometry (help_button, MBUTTON_W, MBUTTON_H));
  widget_set_geometry (quit_button, MBUTTON_W, MBUTTON_H);

  NM1CL (widget_configure (speed_button, resource_text, "speed"));
  widget_configure (visible_button, resource_text, "visible");
  X11CL (widget_configure (autoplay_button, resource_text, "autoplay"));
  NMCL (widget_configure (auto_after_reach_button, resource_text, "auto(R)"));
  widget_configure (flush_button, resource_text, "flush");
  X11CL (widget_configure (restart_button, resource_text, "restart"));
  X11CL (widget_configure (one_button, resource_text, "solitaire"));
  NMCL (widget_configure (auto_button, resource_text, "run auto"));
  widget_configure (about_button, resource_text, "about");
  NMX (widget_configure (help_button, resource_text, "help"));
  widget_configure (quit_button, resource_text, "quit");

  NMX (widget_configure (sound_button, resource_textfont, TIMESI));
  widget_configure (stop_button, resource_textfont, TIMESI);
  NM1CL (widget_configure (speed_button, resource_textfont, TIMESI));
  widget_configure (visible_button, resource_textfont, TIMESI);
  X11CL (widget_configure (autoplay_button, resource_textfont, TIMESI));
  NMCL (widget_configure (auto_after_reach_button, resource_textfont, TIMESI));
  widget_configure (flush_button, resource_textfont, TIMESI);
  X11CL (widget_configure (restart_button, resource_textfont, TIMESI));
  X11CL (widget_configure (one_button, resource_textfont, TIMESI));
  NMCL (widget_configure (auto_button, resource_textfont, TIMESI));
  widget_configure (about_button, resource_textfont, TIMESI);
  NMX (widget_configure (help_button, resource_textfont, TIMESI));
  widget_configure (quit_button, resource_textfont, TIMESI);

  NMX (widget_add_callback (sound_button,
			    resource_buttonpress_callback,
			    (void *) sound_button_callback, 0));

  widget_add_callback (stop_button,
		       resource_buttonpress_callback,
		       (void *) stop_button_callback, 0);
  widget_add_callback (visible_button,
		       resource_buttonpress_callback,
		       (void *) visible_callback, 0);
  NM1CL (widget_add_callback (speed_button,
			      resource_buttonpress_callback,
			      (void *) speed_callback, 0));
  X11CL (widget_add_callback (autoplay_button,
			      resource_buttonpress_callback,
			      (void *) autoplay_callback, 0));
  NMCL (widget_add_callback (auto_after_reach_button,
			     resource_buttonpress_callback,
			     (void *) auto_after_reach_callback, 0));
  widget_add_callback (flush_button,
		       resource_buttonpress_callback,
		       (void *) flush_callback, 0);
  X11CL (widget_add_callback (restart_button,
			      resource_buttonpress_callback,
			      (void *) restart_callback, 0));
  X11CL (widget_add_callback (one_button,
			      resource_buttonpress_callback,
			      (void *) one_callback, 0));
  NMCL (widget_add_callback (auto_button,
			     resource_buttonpress_callback,
			     (void *) auto_callback, 0));
  widget_add_callback (quit_button,
		       resource_buttonpress_callback,
		       (void *) quit_callback, 0);
  widget_add_callback (about_button,
		       resource_buttonpress_callback,
		       (void *) about_callback, 0);
  NMX (widget_add_callback (help_button,
			    resource_buttonpress_callback,
			    (void *) help_callback, 0));
#endif

  config_button = button_create (status1, MBUTTON_W, MBUTTON_H,
				 "config", white, TIMESI,
				 config_callback, board);
  rule_button = button_create (status1, MBUTTON_W, MBUTTON_H,
			       "rule", white, TIMESI,
			       rule_callback, board);
  flush_button = button_create (status1, MBUTTON_W, MBUTTON_H,
				"flush", white, TIMESI,
				flush_callback, "");
  visible_button = button_create (status1, MBUTTON_W, MBUTTON_H,
				  "visible", white, TIMESI,
				  visible_callback, "");
#if NETMAJ1 && !defined(X11)
  speed_button = button_create (status1, MBUTTON_W, MBUTTON_H,
				"speed", white, TIMESI,
				speed_callback, "");
#endif
#if XCLIENT
  autoplay_button = button_create (status1, MBUTTON_W, MBUTTON_H,
				   "autoplay", white, TIMESI,
				   autoplay_callback, "");
  auto_after_reach_button = button_create (status1, MBUTTON_W, MBUTTON_H,
					   "auto(R)", white, TIMESI,
					   auto_after_reach_callback, "");
  auto_button = button_create (status1, MBUTTON_W, MBUTTON_H,
			       "run auto", white, TIMESI,
			       auto_callback, "");
#endif
#if XCLIENT && X11
  restart_button = button_create (status1, MBUTTON_W, MBUTTON_H,
				  "restart", white, TIMESI,
				  restart_callback, "");
#endif
#if !defined(X11)
  help_button = button_create (status1, MBUTTON_W, MBUTTON_H,
			       "help", white, TIMESI,
			       help_callback, "");
#endif
  about_button = button_create (status1, MBUTTON_W, MBUTTON_H,
				"about", white, TIMESI,
				about_callback, "");
  quit_button = button_create (status1, MBUTTON_W, MBUTTON_H,
			       "quit", white, TIMESI,
			       quit_callback, "");

}


extern integer_t tann, darkgreen, seagreen, darkorange;

void
make_board ()
{
  int i;
  widget_t root, menu, frame, status1, status2;
  widget_t dummy;
  widget_t plane[4];
  char buffer[64];

  colorcombo_init ();		/* for board color change */

/* main board */
  root = board = widget_create ("frame", root_widget);
  widget_set_geometry (board, xwidth, xheight);
  widget_configure (board, resource_name, "board");

/* title and menu buttons */
  menu_frame = status1 = widget_create ("frame", root);
  widget_configure (status1, resource_packed, resource_horizontal);
  title_frame = widget_create ("text", status1);
  widget_set_geometry (title_frame, xwidth - MBUTTON_W * 10 - 4, MBUTTON_H);
#if PAI3D
  sprintf (buffer, "netmaj %s from japan", version);
  widget_configure (title_frame, resource_text, buffer);
  widget_configure (title_frame, resource_textcolor, seagreen);
  widget_configure (title_frame, resource_textfont, 6);
  widget_configure (title_frame, resource_textshadow, 1);
#else
  sprintf (buffer, "netmaj %s", version);
  widget_configure (title_frame, resource_text, buffer);
  widget_configure (title_frame, resource_textcolor, darkorange);
  widget_configure (title_frame, resource_textfont, TIMESIB);
  widget_configure (title_frame, resource_textshadow, 1);
#endif

  build_status (status1);

/* case, dora and uradora frames */
  status_frame = status2 = widget_create ("frame", root);
  widget_configure (status1, resource_wrap, 0);
  widget_configure (status1, resource_packed, resource_horizontal);
  widget_configure (status2, resource_wrap, 0);
  widget_configure (status2, resource_packed, resource_horizontal);
  state_frame = widget_create ("pmcontainer", status2);
  reststr_frame = widget_create ("pmcontainer", status2);
  rest_frame = widget_create ("text", status2);
  widget_configure (rest_frame, resource_textfont, TIMESI);
  mt_reststr_frame = widget_create ("pmcontainer", status2);
  mt_rest_frame = widget_create ("text", status2);
  widget_configure (mt_rest_frame, resource_textfont, HELVB);
  dorastr_frame = widget_create ("pmcontainer", status2);
  dora_frame = widget_create ("pmcontainer", status2);
  uradorastr_frame = widget_create ("pmcontainer", status2);
  uradora_frame = widget_create ("pmcontainer", status2);

  widget_set_geometry (status1, xwidth, TITLE_H + 4);
  widget_configure (status1, resource_border_width, 2);
  widget_set_geometry (status2, xwidth, STATE_H + 4);
  widget_configure (status2, resource_border_width, 2);

  widget_set_geometry (state_frame, 140, STATE_H);
  widget_set_geometry (reststr_frame, STATE_W, STATE_H);
  widget_set_geometry (rest_frame, 30, STATE_H);
  widget_set_geometry (mt_reststr_frame, STATE_W, STATE_H);
  widget_set_geometry (mt_rest_frame, 30, STATE_H);
  widget_set_geometry (dorastr_frame, STATE_W, STATE_H);
  widget_set_geometry (dora_frame, PAI_W * 5, STATE_H);
  widget_set_geometry (uradorastr_frame, STATE_W, STATE_H);
  widget_set_geometry (uradora_frame, PAI_W * 5, STATE_H);

  widget_configure (rest_frame, resource_textcolor, yellow);
  widget_configure (rest_frame, resource_textshadow, 1);

/* user frame */
  for (i = 0; i < 4; i++)
    {
      integer_t pai_width;
      widget_t w, w2;
      plane[i] = widget_create ("frame", root);
      widget_configure (plane[i], resource_packed, resource_horizontal);

      name_frame[i] = widget_create ("frame", plane[i]);
      widget_configure (name_frame[i], resource_border_width, 2);

#if !PAICARD
      user_kaze[i] = widget_create ("pmcontainer", name_frame[i]);
      user_name[i] = widget_create ("text", name_frame[i]);
      w = widget_create ("frame", name_frame[i]);
      widget_configure (w, resource_packed, resource_horizontal);
      user_state[i] = widget_create ("pmcontainer", w);
      mark_frame[i] = widget_create ("pmcontainer", w);
#else
      w = widget_create ("frame", name_frame[i]);
      widget_configure (w, resource_packed, resource_horizontal);
      user_kaze[i] = widget_create ("pmcontainer", w);
      w2 = widget_create ("frame", w);
      user_state[i] = widget_create ("pmcontainer", w2);
      mark_frame[i] = widget_create ("pmcontainer", w2);
      user_name[i] = widget_create ("text", name_frame[i]);
#endif
#if SMALL
      w = widget_create ("frame", name_frame[i]);
      widget_configure (w, resource_packed, resource_horizontal);
      user_gpoint[i] = widget_create ("text", w);
      user_ppoint[i] = widget_create ("text", w);
#else
      user_gpoint[i] = widget_create ("text", name_frame[i]);
      user_ppoint[i] = widget_create ("text", name_frame[i]);
#endif

      pai_width = xwidth - name_width;

      widget_configure (user_name[i], resource_textcolor, yellow);
      widget_configure (user_name[i], resource_textfont, MEDIUMJP);
      widget_configure (user_name[i], resource_textshadow, 1);
      widget_configure (user_gpoint[i], resource_textcolor, yellow);
      widget_configure (user_ppoint[i], resource_textcolor, white);
      widget_configure (user_ppoint[i], resource_textshadow, 1);
      widget_configure (user_gpoint[i], resource_textshadow, 1);
      widget_configure (user_ppoint[i], resource_textfont, TIMESI);
      widget_configure (user_gpoint[i], resource_textfont, TIMESI);

      pai_frame[i] = widget_create ("frame", plane[i]);
      widget_configure (pai_frame[i], resource_border_width, 2);

      {
	linepos_frame[i] = widget_create ("frame", pai_frame[i]);
	widget_set_geometry (linepos_frame[i], pai_width - 4, 1);
	widget_configure (linepos_frame[i], resource_wrap, 0);
      }
      river_attr1[i] = widget_create ("pmcontainer", pai_frame[i]);
      river_frame[i] = widget_create ("pmcontainer", pai_frame[i]);
      river_attr2[i] = widget_create ("pmcontainer", pai_frame[i]);
      river_attr3[i] = widget_create ("pmcontainer", pai_frame[i]);
      river_attr4[i] = widget_create ("pmcontainer", pai_frame[i]);
      hand_frame[i] = widget_create ("pmcontainer", pai_frame[i]);
#ifndef SMALL
      openhand_frame[i] = widget_create ("pmcontainer", pai_frame[i]);
      widget_set_geometry (openhand_frame[i], pai_width - 4, PAI_H);
      widget_configure (openhand_frame[i], resource_pixmapstart, PAI_W * 9);
#endif
      widget_set_geometry (river_attr1[i], pai_width - 4, ATTR_H);
      widget_set_geometry (river_frame[i], pai_width - 4, PAI_H);
      widget_set_geometry (river_attr2[i], pai_width - 4, ATTR_H);
      widget_set_geometry (river_attr3[i], pai_width - 4, ATTR_H);
      widget_set_geometry (river_attr4[i], pai_width - 4, ATTR_H);
      widget_set_geometry (hand_frame[i], pai_width - 4, PAI_H);

      widget_configure (hand_frame[i], resource_pixmapstart, HANDPAISTART);
      if (i == 3)
	{
	  hand_pai_advice_info = widget_create ("pmcontainer", pai_frame[i]);
	  widget_configure (hand_pai_advice_info, resource_pixmapstart,
			    HANDPAISTART);
	  widget_set_geometry (hand_pai_advice_info, pai_width - 4, 8);
	}
      widget_add_callback (hand_frame[i],
			   resource_buttonpress_callback,
			   (void *) select_pai_callback, i);
      widget_pack (pai_frame[i]);
      widget_configure (pai_frame[i], resource_wrap, 0);

      {
	integer_t w, h;
	widget_get_geometry (pai_frame[i], &w, &h);

	widget_set_geometry (user_name[i], name_width - 4, NAME_H + 4);
#if !PAICARD
	widget_set_geometry (user_kaze[i], name_width - 4, STATE_H);
	widget_set_geometry (mark_frame[i], (name_width - 4) / 2, USERSTATE_H);
	widget_set_geometry (user_state[i], (name_width - 4) / 2, USERSTATE_H);
#else
	widget_set_geometry (user_kaze[i], name_width - 28, 28);
	widget_set_geometry (mark_frame[i], 24, USERSTATE_H);
	widget_set_geometry (user_state[i], 24, USERSTATE_H);
#endif


#ifndef SMALL
	widget_set_geometry (user_gpoint[i], name_width - 4, DIGIT_H);
	widget_set_geometry (user_ppoint[i], name_width - 4, DIGIT_H);
#else
	widget_set_geometry (user_gpoint[i], (name_width - 4) / 2, DIGIT_H);
	widget_set_geometry (user_ppoint[i], (name_width - 4) / 2, DIGIT_H);
#endif
	widget_pack (name_frame[i]);	/* calculation of sizeof name_frame  */
	widget_configure (name_frame[i], resource_wrap, 0);
	widget_set_geometry (name_frame[i], name_width, h);
      }
    }

/* action frame */
  {
    widget_t paiselectaction;
    integer_t i = 0;
    action = widget_create ("frame", root);
    paiselectaction = widget_create ("frame", action);
    widget_configure (paiselectaction, resource_packed, resource_horizontal);

    choicestate_frame = widget_create ("pmcontainer", paiselectaction);
    widget_set_geometry (choicestate_frame, PAI_W * 3, PAI_H + 4);
    i += (PAI_W * 3);
    choice_frame = widget_create ("pmcontainer", paiselectaction);
    widget_set_geometry (choice_frame, PAI_W * 10, PAI_H + 4);
    i += (PAI_W * 10);
    advicepmframe = widget_create ("pmcontainer", paiselectaction);
    widget_set_geometry (advicepmframe, xwidth - i, PAI_H + 4);
  }
  {
    widget_t buttonaction = widget_create ("frame", action);
    widget_configure (buttonaction, resource_packed,
		      resource_horizontal);
    cancel_button = widget_create ("button", buttonaction);
    advice_button = widget_create ("button", buttonaction);
    tie_button = widget_create ("button", buttonaction);
    pon_button = widget_create ("button", buttonaction);
    kan_button = widget_create ("button", buttonaction);
    reach_button = widget_create ("button", buttonaction);
    tumo_button = widget_create ("button", buttonaction);
    ron_button = widget_create ("button", buttonaction);
    actionbutton_setup ();
/*  widget_configure (cancel_button, resource_text, "cancel");
   widget_configure (kan_button, resource_text, "kan");
   widget_configure (tumo_button, resource_text, "tumo");
   widget_configure (tie_button, resource_text, "tie");
   widget_configure (pon_button, resource_text, "pon");
   widget_configure (ron_button, resource_text, "ron");
   widget_configure (reach_button, resource_text, "reach"); */


    widget_set_geometry (advice_button, ACTBUTTON_W, BUTTON_H);
    widget_set_geometry (cancel_button, ACTBUTTON_W, BUTTON_H);
    widget_set_geometry (kan_button, ACTBUTTON_W, BUTTON_H);
    widget_set_geometry (tumo_button, BUTTON_W, BUTTON_H);
    widget_set_geometry (tie_button, ACTBUTTON_W, BUTTON_H);
    widget_set_geometry (pon_button, ACTBUTTON_W, BUTTON_H);
    widget_set_geometry (reach_button, ACTBUTTON_W, BUTTON_H);
    widget_set_geometry (ron_button, BUTTON_W, BUTTON_H);
    widget_pack (buttonaction);
    widget_pack (action);
  }
  widget_add_callback (advice_button,
		       resource_buttonpress_callback,
		       (void *) advice_button_callback, "advice");
  widget_add_callback (cancel_button,
		       resource_buttonpress_callback,
		       (void *) cancel_button_callback, "cancel");
  widget_add_callback (kan_button,
		       resource_buttonpress_callback,
		       (void *) kan_button_callback, "kan");
  widget_add_callback (tumo_button, resource_buttonpress_callback,
		       (void *) tumo_button_callback, "tumo");
  widget_add_callback (tie_button, resource_buttonpress_callback,
		       (void *) tie_button_callback, "tie");
  widget_add_callback (pon_button, resource_buttonpress_callback,
		       (void *) pon_button_callback, "pon");
  widget_add_callback (reach_button, resource_buttonpress_callback,
		       (void *) reach_button_callback, "reach");
  widget_add_callback (ron_button, resource_buttonpress_callback,
		       (void *) ron_button_callback, "ron");
  widget_add_callback (choice_frame,
		       resource_buttonpress_callback,
		       (void *) select_pai_callback, 5);
#if COMMUNICATION == 1
  {				/* communication */
    widget_t comm = widget_create ("frame", root);
    widget_t strbox[3];
    widget_t strs[15];
    int i, j, k = 0;
    extern char talk_messages[15][60];
    void send_play_message_callback ();

    widget_configure (comm, resource_packed, resource_horizontal);
    widget_set_geometry (comm, xwidth, 5 * JPFONTHEIGHT);
    strbox[0] = widget_create ("frame", comm);
    widget_set_geometry (strbox[0], xwidth / 3, 5 * JPFONTHEIGHT);
    strbox[1] = widget_create ("frame", comm);
    widget_set_geometry (strbox[1], xwidth / 3, 5 * JPFONTHEIGHT);
    strbox[2] = widget_create ("frame", comm);
    widget_set_geometry (strbox[2], xwidth / 3, 5 * JPFONTHEIGHT);

    for (i = 0; i < 3; i++)
      {
	widget_t f = widget_create ("frame", strbox[i]);
	widget_set_geometry (f, 8, JPFONTHEIGHT + 2);
	widget_configure (f, resource_wrap, 0);
	for (j = 0; j < 5; j++)
	  {
	    strs[k] = widget_create ("text", strbox[i]);
	    widget_set_geometry (strs[k], xwidth / 3 - 8, JPFONTHEIGHT + 2);
	    widget_configure (strs[k], resource_text, &talk_messages[k]);
	    widget_configure (strs[k], resource_textfont, SMALLJP);
	    widget_add_callback (strs[k], resource_buttonpress_callback,
				 send_play_message_callback, k);
	    k++;
	  }
	widget_pack (strbox[i]);
      }
    widget_pack (comm);
  }
#endif

  widget_pack (root);
  widget_fix (root);
  message_init ((widget_t *) & pai_frame, (widget_t *) & hand_frame);

  bind_save (resource_button3press_callback,
	     (void *) board_button3press_callback, 0);

  widget_set_geometry (root, xwidth, xheight);
}

void 
linepos_clear ()
{
  integer_t i;
  for (i = 0; i < 4; i++)
    {
      widget_configure (linepos_frame[i], resource_cannot_change_model, 0);
      widget_model_change (linepos_frame[i],
			   get_basiccolorpixel (),
			   white, white, white);
    }
}

static void 
linepos_config ()
{
  if (!flag_linepos)
    {
      linepos_clear ();
    }
}

void
board_redraw (sfx)
     integer_t sfx;
{
  extern boolean button_map_p, button_map_flag;
  integer_t flag = button_map_flag;
  integer_t map = button_map_p;

  stop_config ();
  autoplay_config ();
  auto_after_reach_config ();
  speed_config ();
  sound_config ();
  invisible_config ();
  linepos_config ();

  widget_map (board);
  message_unmap ();
  advice_clear ();
  if (map)
    {
      board_button_unmap ();
      board_button_map (flag);
      board_display ();
      board_button_display (flag);
    }
  else
    {
      board_button_unmap ();
      board_display ();
    }

  if (flag_redrawsfx && sfx)
    {
      board_flush_sfx ();
    }
  else
    {
      board_flush ();
    }
  if (map && flag_advicealways)
    {
      advice_button_callback (0, 0, 0);
    }
  msg_bg_init ();
}

void 
board_sfx_redraw ()
{
  board_redraw (1);
}

void
board_reset ()
{
  int i;
  extern boolean button_map_p;
  board_button_unmap ();
  for (i = 0; i < 4; i++)
    {
      pmcontainer_clear (river_attr1[i]);
      pmcontainer_clear (river_frame[i]);
      pmcontainer_clear (river_attr2[i]);
      pmcontainer_clear (river_attr3[i]);
      pmcontainer_clear (river_attr4[i]);
      pmcontainer_clear (hand_frame[i]);
      pmcontainer_clear (mark_frame[i]);
      widget_display (river_attr1[i]);
      widget_display (river_frame[i]);
      widget_display (river_attr2[i]);
      widget_display (river_attr3[i]);
      widget_display (river_attr4[i]);
      widget_display (hand_frame[i]);
      widget_display (mark_frame[i]);
      widget_flush (river_attr1[i]);
      widget_flush (river_frame[i]);
      widget_flush (river_attr2[i]);
      widget_flush (river_attr3[i]);
      widget_flush (river_attr4[i]);
      widget_flush (hand_frame[i]);
      widget_flush (mark_frame[i]);
#ifndef SMALL
      pmcontainer_clear (openhand_frame[i]);
      widget_configure (openhand_frame[i], resource_pixmapstart, (PAI_W * 7));
      widget_display (openhand_frame[i]);
      widget_flush (openhand_frame[i]);
#endif
    }
  widget_event_discard (root_widget);
  widget_sync (root_widget);
}
