/*  -*- Mode: C -*- 
 * This file is part of my project
 * 
 * itime.c -- 
 * 
 * $Id$
 * Author          : NBC02365@niftyserve.or.jp
 * Created On      : Wed Jun  7 04:51:46 1995
 * Last Modified By: NBC02365@niftyserve.or.jp
 * Last Modified On: Tue Sep 26 22:23:14 1995
 * 
 *  Copyright (C) 1995,1996 Todo Software All rights reserved
 */

#include <signal.h>

static int (*handler) ();
static int timer_interval;

static int
timer_handler_invoke ()
{
  if (handler)
    (*handler) ();

#if SYSV || defined(linux)
  signal (SIGALRM, (void *) timer_handler_invoke);
#endif
  alarm (timer_interval);
}

#include <sys/time.h>

#define BACKGROUND 1

#if BACKGROUND
void
set_timer_handler (func, interval)
     int (*func) ();
{
  handler = func;
  signal (SIGALRM, (void *) timer_handler_invoke);
  alarm (timer_interval = interval);
}

void
clear_timer_handler ()
{
  alarm (0);
  signal (SIGALRM, SIG_IGN);
}

void
stop_timer ()
{
  alarm (0);
}

void
resume_timer ()
{
  alarm (timer_interval);
}

#else

void
set_timer_handler (func, interval)
     int (*func) ();
{
}

void
clear_timer_handler ()
{
}

void
stop_timer ()
{
}

void
resume_timer ()
{
}


#endif
