/*  -*- Mode: C -*- 
 * This file is part of my project
 * 
 * testpai.c -- 
 * 
 * $Id$
 * Author          : NBC02365@niftyserve.or.jp
 * Created On      : Thu May 11 10:27:04 1995
 * Last Modified By: NBC02365@niftyserve.or.jp
 * Last Modified On: Mon Jan  8 18:00:03 1996
 * 
 *  Copyright (C) 1995,1996 Todo Software All rights reserved
 */
#include "xnet.h"
#include "pixread.h"
#include "xnetmaj.h"
#include "ruledef.h"

static widget_t rule;
static widget_t rules[15];

void
ruleview_init ()
{
  widget_t frames[7], canvas, framepoint;
  integer_t i, x, y;
  extern integer_t xwidth, xheight;
  extern widget_t root_widget;
  extern integer_t xwidth, xheight;

  rule = widget_create ("frame", root_widget);
  widget_configure (rule, resource_name, "rule");
  widget_set_geometry (rule, xwidth, xheight);

  framepoint = create_basic_info_frame ("frame",
					rule,
					frames,
					PAI_W * 18,
					0, 1);
  widget_configure (frames[4], resource_frame_start, 270);
  widget_get_geometry (framepoint, &x, &y);
  widget_set_geometry (frames[0], xwidth, 5);

  for (i = 0; i < 15; i++)
    {
      rules[i] = canvas = widget_create ("text", framepoint);
      widget_set_geometry (canvas, xwidth, 18);
      widget_configure (canvas, resource_textfont, MEDIUMJP);
    }

  widget_pack (rule);
  widget_fix (rule);

  widget_set_geometry (rule, xwidth, xheight);
}

static void
rule_draw ()
{
  char *p;
  char buffer[128];
  int i = 0;
  if (!rule)
    ruleview_init ();
  if (RL_NOPINTUMO)
    {
      p = "ԥťʤ: ĤäȤϡԥդĤʤ";
    }
  else
    {
      p = "ԥť⤢: ĤäȤԥդĤ";
    }
  widget_configure (rules[i++], resource_text, p);

  if (RL_NOAKADORA)
    {
      p = "֥ɥʤ: ֥ɥϡɥ鰷ˤʤ";
    }
  else
    {
      p = "֥ɥ餢: ֥ɥϡɥ鰷";
    }
  widget_configure (rules[i++], resource_text, p);

  if (RL_NONAKITAN)
    {
      p = "ʤʤ: ʤϥ䥪Ĥʤ";
    }
  else
    {
      p = "ʤ󤢤: ʤ⥿䥪Ĥ";
    }
  widget_configure (rules[i++], resource_text, p);

  if (RL_NOKANURA)
    {
      p = "󥦥ʤ: ɥϣΤ";
    }
  else
    {
      p = "󥦥餢: 󥦥⥦ɥȤ";
    }
  widget_configure (rules[i++], resource_text, p);

  if (RL_NOFLY)
    {
      p = "ȤӤʤ: ʤ/Ȣ׻⤢";
    }
  else
    {
      p = "ȤӤ: /Ȣ׻ʤ";
    }
  widget_configure (rules[i++], resource_text, p);

  if (RL_UNDER)
    {
      p = "Ȣ׻: 0 ʲʬ 0 ˤ׻";
    }
  else
    {
      p = "Ȣ׻ʤ: 0 ʲʬ 0 ˷׻";
    }
  widget_configure (rules[i++], resource_text, p);

  sprintf (p = buffer, "೫ϻλ %d ", RL_STARTPOINT);
  widget_configure (rules[i++], resource_text, p);

  sprintf (p = buffer, "˵  %d ", RLC_YAKUMAN);
  widget_configure (rules[i++], resource_text, p);

  sprintf (p = buffer, "ȯ˵ %d ", RLC_IPPATU);
  widget_configure (rules[i++], resource_text, p);

  sprintf (p = buffer, "ɥ˵ %d ", RLC_URADORA);
  widget_configure (rules[i++], resource_text, p);

  sprintf (p = buffer, "֥ɥ˵ %d ", RLC_AKADORA);
  widget_configure (rules[i++], resource_text, p);

  if (RLC_NONAKIAKA)
    {
      p = "֥ɥΤ: ʤ֥ɥ餬Ĥʤ";
    }
  else
    {
      p = "֥ɥ˸¤餺֥ɥȤ";
    }
  widget_configure (rules[i++], resource_text, p);

  if (RLC_NOALLSTARS)
    {
      p = "륹ʤ: ֥ɥ罸᤿Ȥθ˵(2)";
    }
  else
    {
      p = "륹: ֥ɥ罸᤿Ȥθ˵(2)";
    }
  widget_configure (rules[i++], resource_text, p);

  widget_map (rule);

  widget_display (rule);
  widget_flush (rule);
  wait_key ();
}

void rule_callback callbackarg_param
{
  extern widget_t board;
  extern widget_t about;

  if (board)
      widget_unmap (board);
  if (about)
      widget_unmap (about);

    rule_draw ();

    widget_unmap (rule);
    board_redraw (1);
}
